from __calcularcosto import calcularcosto
from __subdividir import subdividir


def optimizar_division (bits, largo):

		divs = [(n, largo - n) for n in range (1, largo)]

		dimensiones = []
		costos = []
		for largoAB, largoCD in divs:
			bases, largos = subdividir (bits, largoAB, largoCD)
			c = calcularcosto (bases, largos)
			dimensiones += [(bases, largos)]
			costos += [c]

		minimo = min (costos)
		indice = costos.index (minimo)
		basesMin, largosMin = dimensiones[indice]
		return basesMin, largosMin


# ----------------------------------------------------------------
if __name__ == '__main__':

	bits = 128
	largo = 64

	b, L = optimizar_division (bits, largo)

	print ('bits, largo = ' + str ((bits, largo)))
	print ('bases, largos = ' + str ((b, L)))

