import os
from hashlib import sha256, sha512
from __aplicarUps import aplicarUps
from __comprimir import comprimir
from __expandir import expandir


try: xrange
except: xrange = range


def crearfuncion_claves (zetas, comprimido, consal, cbits, upbits):
	largo = len (zetas)

	def crearclaves ():
		sal = sha256 (os.urandom (64)).digest () if consal else b''

		seed = sha512 (os.urandom (128)).digest ()
		clavepriv = expandir (seed, upbits, largo)

		# aplicar ups
		clavepub = aplicarUps (clavepriv, ups=zetas, sal=sal, inicio=True, zetas=zetas)

		priv = {'clave': seed if comprimido else clavepriv, 'sal': sal}
		pub = comprimir (clavepub, cbits) if comprimido else clavepub
		return priv, pub

	return crearclaves


# ----------------------------------------------------------------
if __name__ == '__main__':

	zetas = 10, 10, 10, 10
	cbits = 100

	crearclaves = crearfuncion_claves (zetas, comprimido=True, consal=True, cbits=64, upbits=64)
	priv, pub = crearclaves ()

	print ('pub = ' + repr (pub))

